﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private cnvs As B4XCanvas
	Private DiceRect As B4XRect
	Private btnroll As Button
	Private pnlmain As Panel
	Private pnlsettings As Panel
	Private dnames As List = Array As String("D1","D2","D3","D4","D5","D6")
	Private imagesmap As Map
	Private dicemap As Map
	Private cbx1 As B4XComboBox
	Private panelcnt As Int = 1
	Private cbx2 As B4XComboBox
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Roll The Dice")
	dicemap.Initialize
	imagesmap.Initialize
	DiceRect.Initialize(5dip,5dip,80dip,80dip)
	fill_images_map
	fill_cbx1
	fill_cbx2
	fill_dicemap_with_colors
	btnroll_Click
End Sub
Private Sub fill_images_map
	Private whiteimages As List = Array As String("white_D1.jpg","white_D2.jpg","white_D3.jpg","white_D4.jpg","white_D5.jpg","white_D6.jpg")
	Private blueimages As List = Array As String("blue_D1.jpg","blue_D2.jpg","blue_D3.jpg","blue_D4.jpg","blue_D5.jpg","blue_D6.jpg")
	Private greenimages As List = Array As String("green_D1.jpg","green_D2.jpg","green_D3.jpg","green_D4.jpg","green_D5.jpg","green_D6.jpg")
	Private orangeimages As List = Array As String("orange_D1.jpg","orange_D2.jpg","orange_D3.jpg","orange_D4.jpg","orange_D5.jpg","orange_D6.jpg")
	Private redimages As List = Array As String("red_D1.jpg","red_D2.jpg","red_D3.jpg","red_D4.jpg","red_D5.jpg","red_D6.jpg")
	Private yellowimages As List = Array As String("yellow_D1.jpg","yellow_D2.jpg","yellow_D3.jpg","yellow_D4.jpg","yellow_D5.jpg","yellow_D6.jpg")
	imagesmap.Put("blue",blueimages)
	imagesmap.Put("green",greenimages)
	imagesmap.Put("red",redimages)
	imagesmap.Put("white",whiteimages)
	imagesmap.Put("yellow",yellowimages)
	imagesmap.Put("orange",orangeimages)
End Sub
Private Sub btnroll_Click
	Private tries As Int = Rnd(5,20)
	btnroll.Enabled = False
	Sleep(100)
	For x = 1 To tries
		Private r(6) As Int
		For i = 0 To 5
			r(i) = Rnd(1,7)
		Next
		show_panels(panelcnt,r)
		Sleep(100)		
	Next
	btnroll.Enabled = True
End Sub
Private Sub fill_dicemap_with_colors
	For i = 0 To dnames.Size - 1
		Select cbx2.SelectedItem
			Case "blue"
				dicemap.Put(dnames.Get(i),imagesmap.Get("blue").As(List).Get(i))
			Case "green"
				dicemap.Put(dnames.Get(i),imagesmap.Get("green").As(List).Get(i))
			Case "orange"
				dicemap.Put(dnames.Get(i),imagesmap.Get("orange").As(List).Get(i))
			Case "red"
				dicemap.Put(dnames.Get(i),imagesmap.Get("red").As(List).Get(i))
			Case "white"
				dicemap.Put(dnames.Get(i),imagesmap.Get("white").As(List).Get(i))
			Case "yellow"
				dicemap.Put(dnames.Get(i),imagesmap.Get("yellow").As(List).Get(i))
		End Select
	Next
	Log(dicemap)
End Sub
Private Sub show_roll(pnl As Panel, roll As Int)
		cnvs.Initialize(pnl)
		cnvs.DrawRect(DiceRect, Colors.Black, False, 0dip)
		Dim bmp As Bitmap
		bmp.Initialize(File.DirAssets, dicemap.Get("D" & roll))
		cnvs.DrawBitmap(bmp, DiceRect)
End Sub
Private Sub fill_cbx1
	Private lst As List = Array As String("1 dice","2 dice","3 dice","4 dice","5 dice","6 dice")
	cbx1.SetItems(lst)
	cbx1.SelectedIndex = -1
End Sub
Private Sub cbx1_SelectedIndexChanged (Index As Int)
	panelcnt = Index + 1
	btnroll_Click
End Sub
Private Sub show_panels(numpnls As Int, rolls() As Int)
	pnlmain.RemoveAllViews
	Private left As Int = 20dip
	Private top As Int  = 15dip
	For i = 1 To numpnls
		Private pnl As Panel
		pnl.Initialize("pnl")
		pnlmain.AddView(pnl,left,top,80dip,80dip)
		show_roll(pnl,rolls(i-1))
		If i Mod 3 = 0 Then
			left = 20dip
			top = top + 90dip
		Else
			left = left + 90dip			
		End If
	Next
End Sub
Private Sub fill_cbx2
	Private lst As List = Array As String("blue","green","red","white","yellow","orange","mixed")
	cbx2.SetItems(lst)
	cbx2.SelectedIndex = 0
End Sub
Private Sub cbx2_SelectedIndexChanged (Index As Int)
	If cbx2.SelectedItem = "mixed" Then
		Private colorlst As List = Array As String("blue","green","red","white","yellow","orange")
		Dim lst As List
		lst.Initialize
		lst.Clear
		Dim num As Int
		For x = 1 To 6
			num = Rnd(1,7)
			Do While lst.IndexOf(num) <> -1
				num = Rnd(1,7)
			Loop
			lst.Add(num)
		Next
		dicemap.Clear
		For i = 0 To lst.Size -1
			Dim clrstr As String = colorlst.Get(lst.Get(i)-1)
			dicemap.Put(dnames.Get(i),imagesmap.Get(clrstr).As(List).Get(i))
		Next
	Else
		fill_dicemap_with_colors		
	End If
	btnroll_Click
	cbx2.SelectedIndex = -1
End Sub
